program AsmBeautifier;
{ Source beautifier skeleton for ASSEMBLER; procedure and functions

Very simple and very Alpha source beautifier, which beautifies
 ONLY asssembler; procedures and functions. The rest is untouched.

Most things are still hardcoded. I started commenting, but that's not ready

Things that have to be improved:
- AsmLine and opcodeOperanddist configurable, have to sort out GetOpt first, if
   it also works under DOS. Don't want to fool around with paramstr. Otherwise
   I'll use the old GetSwitch skeleton.
- Scanning for implementation keyword can be turned off with switch
- Comment distance should be implemented.


No space(s) allowed between label and ':', like the ATT style.
}

{$I syseq.inc}

Uses EPasStr,EFIO;

VAR     AsmLine,                    { Position of column with opcodes, from
                                       start of line}
        opcodeOperanddist,          { Max width opcode+1 (movzwl=6, so 7 is
                                      minimal}
        OperandcommentDist,         { Distance start of operand-
                                        comment column}

        AsmLineDef,                 { Default values for above variables}
        opcodeOperanddistDef,       { Reset at every END[ statement }
        OperandcommentDistDef : WORD;
        InterF : BOOLEAN;           { TRUE while in Interface}


PROCEDURE BeatOneFile(FileName:String); {Typo, should be BeautOneFile,
                                          but I liked the irony }

     { the main line of code starts after this column}
      { length Biggest opcode +1 (movzwl=6 chars) }
      { begin operand-comment distance}

VAR F1,F2  : Text;          {Textfiles}

PROCEDURE BeautyLine(InString:String);

VAR LabelStr :String;
    A: WORD;

FUNCTION TestForComment(Level:Word):BOOLEAN;
{ Tests for comment}

BEGIN
 LTrim(InString,' ');                           {remove spaces}
 IF InString[1]='{' THEN                        {Comment?}
  BEGIN
   LabelStr:=InString;                         {Test if comment is a directive}
   Uppercase(LabelStr);
   IF Copy(LabelStr,2,6)='$ENDIF' THEN         {ENDIF terminates indentation}
    DEC(AsmLine);
   IF Level=0 THEN                             {Indent if on level 0}
    Write(F2,' ':AsmLine);
   IF Copy(LabelStr,2,6)='$IFDEF' THEN         {IFDEF/IFNDEF start indentation}
    INC(AsmLine);
   IF Copy(LabelStr,2,7)='$IFNDEF' THEN
    INC(AsmLine);
   Writeln(F2,InString);
   TestForComment:=TRUE;
  END
 ELSE
  TestForComment:=FALSE;
END;

BEGIN
 IF Not TestForComment(0) THEN
  BEGIN                            {No comment-line}
   IF Length(InString)=0 THEN    {Test for empty string or space-only string}
    BEGIN
     Writeln(F2);
     EXIT;
    END;
   Item(LabelStr,InString,' ',0);
   IF LabelStr[ORD(LabelStr[0])]=':' THEN      {Test for Label}
     BEGIN {Label}
     IF Length(LabelStr)>(AsmLine-2) THEN
      BEGIN   {Label longer than normal, write on separate line}
       Writeln(F2,LabelStr);
       Delete(InString,1,Length(LabelStr)); {delete from string}
       LTrim(InString,' ');
       Write(F2,' ':AsmLine);
      END
     ELSE
      BEGIN   {Normal label}
       Delete(InString,1,Length(LabelStr));
       RGrow(LabelStr,' ',AsmLine);
       Write (F2,LabelStr);
       LTrim(InString,' ');
       IF Length(Instring)=0 THEN
        writeln(f2);
      END;
     END
    ELSE { No label, skip with spaces}
     Write(F2,' ':AsmLine);
    IF NOT Testforcomment(1) Then       { Test for comment after a label}
     BEGIN
      Item(LabelStr,InString,' ',0);    { Pick operand}
      IF Length(LabelStr)>0 THEN
       BEGIN
        writeln(instring);
        Delete(InString,1,Length(LabelStr));
        RGrow(LabelStr,' ',opcodeOperanddist);

        Write(F2,LabelStr);                    {Opcode}
        LTrim(InString,' ');
        A:=Pos('//',InString);          {Comment?}
        IF A<>0 THEN
         BEGIN                           {Process comment}
          LabelStr:=InString;
          Instring[0]:=CHR(A-1);
          RTrim(Instring,' ');
          Delete(LabelStr,1,A-1);
          RGrow(InString,' ',OperandcommentDist);
          Write(F2,InString);           {Write operand}
          Writeln(F2,LabelStr);
         END
        ELSE
         Writeln(F2,InString);          {Write operand}
        END;
     END;
 END;
END;

VAR
    S,S2   : String;

    AsmProc: BOOLEAN;       {TRUE in assembler procedure}

    SkipAsm: BOOLEAN;       {Used to signal after a asm procedure is detected.
                             signals to skip to ASM statement}
    Fl     : BOOLEAN;
    A      : WORD;

BEGIN
 S:=FileName;
 ChangeExtension(S,'tmp');
 Assign(F1,FileName);
 reset(F1);
 Assign(F2,S);
 rewrite(F2);


 {Parse to start of implementation if InterF=TRUE}

 WHILE (NOT EOF(F1)) AND InterF DO
  BEGIN 
   ReadLn(F1,S);
   S2:=S;
   UpperCase(S2);
   IF Pos('IMPLEMENTATION',S2)>0 THEN
    InterF:=FALSE;
   Writeln(F2,S);
  END;

 {Real beautifier routine}

 AsmProc:=FALSE;
 WHILE NOT EOF(F1) DO
  BEGIN
   READLN(F1,S);

   {Copy string and remove trailing asm (//) comments from the copy,
     so that keywords in asm comments are ignored}

   S2:=S;
   UpperCase(S2);
   LTrim(S2,' ');
   A:=Pos('//',S2);
   IF A<>0 THEN
    S2[0]:=CHR(A);

   SkipAsm:=FALSE;

   IF S2[1]<>'{' THEN       { check if pascal comments exist}
     BEGIN
      {The following pos'es try to isolate assembler procedures.
         ASMProc:=TRUE means in an assembler procedure.}

      Fl:= (Pos('ASSEMBLER;',S2)>0);
      IF Pos('PROCEDURE',S2)>0  THEN
       IF Fl THEN
        BEGIN
         AsmProc:=TRUE;
         SkipAsm:=TRUE;
        END
      ELSE
       AsmProc:=FALSE;
      IF Pos('FUNCTION',S2)>0 THEN
       IF Fl THEN
        BEGIN
         AsmProc:=TRUE;
         SkipAsm:=TRUE;
        END
      ELSE
        AsmProc:=FALSE;
      StripChar(S2,' '); { push [ against END to detect END[ with one pos}
      IF Pos('END[',S2)>0 THEN
       BEGIN
        LTrim(S,' ');
        UpperCase(S);
        AsmProc:=FALSE;
       END;
     END;


   IF SkipAsm THEN {Skip all between PROCEDURE /FUNCTION and ASM statement}
    BEGIN
     Writeln(F2,S);
     REPEAT
      readln(F1,S);
      S2:=S;
      UpperCase(S2);
      LTrim(S2,' ');
      A:=Pos('//',S2);
      IF A<>0 THEN
       S2[0]:=CHR(A);
      IF ((S2[1]='A') AND (S2[2]='S')) AND (S2[3]='M') THEN
        SkipAsm:=FALSE;
      IF EOF(F1) THEN
       SkipAsm:=FALSE;
      writeln(F2,S);
      UNTIL NOT SkipAsm;

      READLN(F1,S);
      AsmLine:=AsmLineDef;
      opcodeOperanddist:=opcodeOperanddistDef;
      OperandcommentDist:=OperandcommentDistDef;
     END;


   IF AsmProc THEN { In assembler; procedure/function?}
    BEGIN
     ExpandTabs(S,S2,8); {Get rid of all tabs}
     BeautyLine(S2);     {Process line}
    END
   ELSE
    BEGIN
     Writeln(F2,S);       {No assembler; procedure, just plain copy.}
    END;
  END;
 Close(F1); Close(F2);
 S:=FileName;
 ChangeExtension(S,'bak');
 IF FileExists(S) THEN
 BEGIN
  Assign(F1,S);
  Erase(F1);
 END;
 Assign(F1,FileName);
 Rename(F1,S);
 S:=FileName;
 ChangeExtension(S,'tmp');
 Assign(F1,S);
 Rename(F1,Filename);
END;

VAR Param : String;
CONST Usage='Usage: AsmBeaut <file>';

BEGIN
{Init defaults}
 AsmLineDef:= 25;                       {First defaults}
 opcodeOperanddistDef:= 7;
 OperandcommentDistDef:= 25;
 InterF:=TRUE;                          {Skip interface part of a unit.}
  IF ParamCount=0 THEN
   Writeln(Usage)
 ELSE
  BEGIN
   Param:=ParamStr(1);
   IF FileExists(Param) THEN
    BeatOneFile(Param)
   ELSE
    Write(Usage);
  END;
END.
