program MP3Creat;

{$I syseq.inc}

Uses EFIO,EPasStr;

TYPE SongPtr=^Song;
     Song= RECORD
             Tagged   : BOOLEAN;
             Artist,
             Name     : String;
             Size     : LONGINT;
             Album    : LONGINT;
             MPICD    : LONGINT;
             END;

     AlbumType= RECORD
             Tagged   : BOOLEAN;
             Artist,
             Name     : String;
             NoSong   : LONGINT;
             AlSongs  : ARRAY[0..50] OF SongPtr;
             DiffPath : String;
             Size     : LONGINT;
             END;


     MPIType= RECORD
               Name       : String[4];
               BasePath   : String;
               END;


VAR  FIn        : File;
     S,S2,S3    : String;
     InAlbum    : BOOLEAN;
     I,I2       : LONGINT;
     Cur        : SongPtr;
     Code       : WORD;
     Album      : ARRAY[0..20] OF AlbumType;
     Songs      : ARRAY[0..5000] OF SongPtr;
     SongAlbum  : ARRAY[0..5000] OF SongPtr;
     SongNr,
     SongInAlbum,
     NrAlbum    : LONGINT;
     MPINr      : LONGINT;

FUNCTION ReadPas(VAR Fx:File;VAR Sin : String):BOOLEAN;
{Read a pascal string from file (one byte length, "length" bytes string)}

VAR I3,I4  : LONGINT;

BEGIN
 I3:=1;
 BlockRead(Fx,Sin[0],I3,I4);
 IF Sin[0]<>CHR(255) THEN
   BlockRead(Fx,Sin[1],ORD(Sin[0]),I3);
 ReadPas:=Sin[0] <>CHR(255);
END;

PROCEDURE ReadThread(NrAlbum:LONGINT);

VAR Fl : BOOLEAN;

BEGIN
 WHILE ReadPas(FIn,S) DO
  BEGIN
   NEW(Songs[SongNr]);
   Songs[SongNr]^.Artist:=S;
   Fl:=ReadPas(Fin,Songs[SongNr]^.Name);
   BlockRead(FIn,Songs[SongNr]^.Size,4);
   Songs[Songnr]^.Album:=NrAlbum;
   Songs[Songnr]^.Tagged:=FALSE;
   Songs[Songnr]^.MPICD:=MPINr;
   IF NrAlbum<>-1 THEN
     WITH Album[NrAlbum] DO
      BEGIN
       AlSongs[NoSong]:=Songs[SongNr];
       INC(NoSong);
      END;
   INC(SongNr);
  END
END;

VAR Fl : BOOLEAN;

PROCEDURE ReadMPI(Name : String;VAR MPI : MPIType);

BEGIN
 S:=Name;
 ChangeExtension(S,'mpi');
 Assign(FIn,S);
 Reset(FIn);

 BlockRead(FIn,S[1],8,I);
 IF I <>8 THEN
  BEGIN
   Writeln('Bad MPI!');
   HALT;
  END;
 S[0]:=CHR(8);
 FOR I:=1 TO 4 DO
  MPI.Name[I]:=S[I];
 MPI.Name[0]:=CHR(4);
 ReadPas(FIn,MPI.BasePath);
 ReadThread(-1);
 WHILE ReadPas(FIn,S) DO
  BEGIN
   Album[NrAlbum].Artist:=S;
   Fl:=ReadPas(FIn,S);
   Album[NrAlbum].Name:=S;
   Fl:=ReadPas(FIn,S);
   Album[NrAlbum].DiffPath:=S;
   Album[NrAlbum].NoSong:=0;
   BlockRead(FIn,Album[NrAlbum].Size,4);
   ReadThread(NrAlbum);
   INC(NrAlbum);
  END;


Close(FIn);
END;


VAR
     MPI        : ARRAY[0..100] OF MPIType;

BEGIN
 SongNr:=0;
 NrAlbum:=0;
 SongInAlbum:=0;
 MPINr:=0;
END.

