Program SysInfo;
{ I used to have a demo in the Modula2 version of this library that
    demonstrated all sysinfo/detection.
  THIS PROGRAN IS GO32V2 ONLY!

  Currently, I only implemented CMOS data. I could also add the drive-search
  loop of DFree.

  PCI part
  }

Uses EDate,EFIO,EDos,Crt,ELib,Go32,EPasStr,Dos;

{$IFNDEF Go32V2}
 Only under Go32V2.
{$ENDIF}

PROCEDURE OnOff(Flag:WORD);
(* Yuck, another one *)

BEGIN
 IF Flag>0 THEN
  WriteLn('Ok')
 ELSE
  WriteLn('Disabled');
END;

PROCEDURE DoDrive(A : BYTE;Drv:CHAR);
(* Also not my most intelligent procedure *)

BEGIN
 Write('Drive ',Drv,' ':19,': ');
 CASE (A AND 7) OF
  0 :  Write('Not available');
  1 :  Write(' 360 KB 5.25 Drive');
  2 :  Write(' 1.2 MB 5.25 Drive');
  3 :  Write(' 720 KB  3.5 Drive');
  4 :  Write('1.44 MB  3.5 Drive');
  5 :  Write('2.88 MB  3.5 drive');
 END;
 Writeln;
END;

PROCEDURE WrText(CONST S:String);
(* This is really LOW, but it works, and making it a procedure
is smaller, and eases the sources readability :-) *)

BEGIN
 Write(S);
 IF ORD(S[0])<26 THEN
  Write(' ':(26-ORD(S[0])));
 Write(': ');
END;

TYPE AMPMT= ARRAY[0..1] OF String[2];

CONST AMPM : AMPMT=('AM','PM');

PROCEDURE Inst(S:String;Tsr:WORD);
(* Aha, this looks better *)

VAR A : WORD;

BEGIN
 WrText(S);
 A:=Installed(Tsr); Write(' ',A, ' ');
 CASE A OF
   255 : Writeln('Installed');
   0   : Writeln('Not installed');
   1   : Writeln('Not installed and not ok to install');
 ELSE
  BEGIN
   IF A>255 THEN
    WriteLn('Error ', (A AND 255),' Occurred while detecting');
   IF (A=128) AND (Tsr=XMSDrv) THEN
    WriteLn('Installed');
  END;
 END;

END;


PROCEDURE GenSysNfo_CMOS;
(* First Screen, mainly CMOS information *)

VAR
    CMOS :  CMOSRec;
    A,B  :  WORD;
    S    :  String;
    AM   :  BOOLEAN;

BEGIN
 GetCMOS(CMOS);
 WrText('Base Memory installed'); Writeln(CMOS.BaseMem:5,' KB');
 WrText('Extended Memory installed'); Writeln(CMOS.XTDMem:5,' KB');
 WrText('DateTime');
 B:=WORD(CMOS.Hr);
 AM:=(CMOS.RTCB AND 2)=0;
 IF AM THEN    { Test AM/PM notation}
  B:=B MOD 12;
 WITH CMOS DO
  DaTiToStr(B,WORD(Min),WORD(Sec),WORD(Day),WORD(Month),
             WORD(Year)+100*WORD(Century),'%w %j %D%L, %y %h:%m:%s',S);
 Write(S);
 IF AM THEN
  Write(' ',AMPM[WORD(CMOS.Hr DIV 12)]);
 Writeln;
 WrText('Alarmtime');
 B:=WORD(CMOS.AlHr);
 IF AM THEN
  B:=B MOD 12;
 WITH CMOS DO
  DaTiToStr(B,WORD(AlMin),WORD(AlSec),0,0,0,'%h:%m:%s',S);
 Write(S);
 IF AM THEN
  Write(' ',AMPM[WORD(CMOS.AlHr DIV 12)]);
 Writeln; Writeln;
 WrText('RTCA register'); WrHex(CMOS.RTCA);Writeln('h');
 WrText('RTCB register'); WrHex(CMOS.RTCB);Writeln('h');
 WrText('RTCC register'); WrHex(CMOS.RTCC);Write('h');
 WrText('  -> Daylightsaving');
 OnOff(WORD(CMOS.RTCB) AND 1);
 WrText('RTCD register'); WrHex(CMOS.RTCD);Write('h');
 WrText('  -> Battery');
 IF (CMOS.RTCD AND 128) <> 0 THEN
  WriteLn ('Ok')
 ELSE
  WriteLn ('Jammed');

 DoDrive((CMOS.DiskType) shr 4 ,'A');
 DoDrive((CMOS.DiskType AND 15) ,'B');
 WrText('Reserved 1');
 WrHex(CMOS.Res1); writeln('h');

 A:=CMOS.HDType SHR 4;
 IF A=15 THEN
  A:=CMOS.HD_C;
 B:=CMOS.HDType AND 15;
 IF B=15 THEN
  B:=CMOS.HD_D;
WrText('First  Harddisk (HD 0) type '); Writeln(A);
WrText('Second Harddisk (HD 1) type '); Writeln(B);
Write(' (Equipment byte)');Writeln;
 A:=CMOS.Equipment;
 WrText('  - No of floppies'); WriteLn( (A SHR 6) +1);
 B:=(A AND 48)  SHR 4;
 WrText('  - Monitor type');
 CASE B OF
    0 :WriteLn('Not CGA or MDA');
    1 :WriteLn('40x25 CGA');
    2 :WriteLn('80x25 CGA');
    3 :WriteLn('MDA (Monochrome)');
  END;
 WrText('  - Display status'); OnOff(A AND 8);
 WrText('  - Keyboard status'); OnOff(A AND 4);
 WrText('  - Coprocessor status'); OnOff(A AND 2);
 WrText('  - Floppy status'); OnOff(A AND 1);
END ;


PROCEDURE GenSys2;
{Commented functions aren't implemented yet}

VAR A : WORD;

BEGIN
 ClrScr;
 WrText('LastDrive');           Writeln(CHR(LastDrv+66));
 WrText('No. floppy drives');   Writeln(NrFloppies);
 WrText('No. harddisks');       Writeln(NrFixedDisks);
 WrText('No. logical drives');  Writeln(NrDrives);
// WrText('FILES (No. filehandles)');                 IO.WrCard(ConfigFiles(),-3);  IO.WrLn;
// WrText('FILES Used');            IO.WrCard(FilesUsed(),-3);
// IO.WrStr('   ->  FILES Unused : ');
// IO.WrCard(ConfigFiles()-FilesUsed(),-3);  IO.WrLn;
 Writeln(' (Installation checks)');
 Inst(' PRINT',Print);
 Inst(' PC LAN redirector',PcLan);
 Inst(' Dos critical errorhandler',DosCrit);
 Inst(' ASSIGN',AssignF);
 Inst(' DRIVER.SYS',Driver);
 Inst(' SHARE.EXE',Share);
 Inst(' Network redirector',Network);
 Inst(' NLSFUNC.COM',NlsFunc);
 Inst(' Graphics.com or CDROM',Graphics);
 WrText(' Windows');      A:=Installed(Windows);
 CASE A OF
   0 :  WriteLn('Not running under Windows');
   2 :  WriteLn('Running under Windows 2.x');
  ELSE
   Writeln('Running under Windows ',A SHR 8,'.',A AND 255);
   END;
 Inst(' ShellB',ShellB);
 Inst(' ANSI.SYS',Ansi);
 Inst(' XMA2EMS',Xma2Ems);
 Inst(' XMS driver',XMSDrv);
 Inst(' ScrnSav2.com',ScrnSav2);
 Inst(' Novell IPX drivers',NovelIpx);
 Inst(' Append',Append);
END;


PROCEDURE DisplUART(H:LONGINT;Name:String;Num:LONGINT);

BEGIN
 WrHex(H); Write('H ',Name,Num);
 IF H=0 THEN
  Writeln(' not defined')
 ELSE
  CASE TestUART(H) OF
      uNoUART : Write(' not present, or blocked by Windows');
      uBadUART: Write(' UART broken or not compatible');
      u8250   : Write(' 8250B');
      u16450  : Write(' 16450');
      u16550  : Write(' 16550');
      u16550a : Write(' 16550A')
  ELSE
    Write(' unknown');
   END;
  Writeln
END;

PROCEDURE DoUarts;

VAR I : LONGINT;
    A : LONGINT;

BEGIN
   ClrScr;
   WriteLn('Port information:');
   WriteLn(' Testing standard COM-port addresses(usually most correct) : ');
   FOR i := 1 TO 4 DO
    DisplUART($02E8+ $100 * (i AND 1) + $10 * ORD(i < 3),'COM',i);
   WriteLn;
   WriteLn('Do you want to test for PS/2 ports (may interfere with soundcard on some mainboards (Y/N)');
   A:=0;
   While (A<255) AND (NOT (CHR(A) IN ['Y','y','N','n'])) DO
    A:=GetKey;
  IF (CHR(A)='Y') OR (CHR(A)='y') THEN
   BEGIN
    FOR i := 3 TO 8 DO
     DisplUART($3220 + $1000 * ((i - 3) DIV 2) + 8 * ORD(NOT ODD(i)),'PS/2 COM',i);
   END
  ELSE
     Writeln('PS/2 com-port check skipped');
   WriteLn;
   WriteLn(' Testing for COM-port addresses as defined in BIOS : ');
   FOR i := 1 TO 4 DO
    BEGIN
     A:=0;
     DosMemGet($40,(I-1)*2,A,2);
     DisplUART(A, 'BIOS COM', i);
    END;
   WriteLn;
END;

PROCEDURE DriveList;

VAR Drv,Counter : LONGINT;
    S           : String;
    OldBool     : BOOLEAN;

BEGIN
 ClrScr;
 Writeln('Drivelist, removable devices without disk loaded are ignored');
 Writeln;
 Counter:=1;
 repeat
  Drv:=DriveType(Counter);
  IF Drv<>0 THEN
   BEGIN
    Write(CHR(Counter+64),':',' ':5);
    CASE Drv OF
     1          : Write('Remote (network, Ramdrive) disk drive');
     2          : Write('Fixed (hard) disk drive');
     3          : Write('Removable (floppy) disk drive');
     4          : BEGIN
                   Write('Substed drive');
                   OldBool:=SubstExpand;
                   SubstExpand:=TRUE;
                   S:=CHR(Counter+64)+':\';
                   TRUENAME(S);
                   Write(' (',S,')');
                   SubstExpand:=OldBool;
                  END;
    5           : Write('Cdrom');
    END;
    Writeln;
   END;

   INC(Counter);
  UNTIL Counter=27;
END;

PROCEDURE ScanPCI;
{ Simple PCI detector. Uses external file pcidata.txt with device names}

TYPE VendPtr = ^Vendor;
     DevPtr  = ^DeviceRec;
     Vendor= RECORD
              NextVendor : VendPtr;
              DevTree    : DevPtr;
              VendorID   : CARDINAL;
              VendorName : String;
              VendorTag  : String;
              END;
     DeviceRec= RECORD
                 NextDev : DevPtr;
                 DeviceID   : CARDINAL;
                 DeviceName,
                 DeviceTag  : String;
                 END;


VAR RVendor,
    CurVend : VendPtr;
    F       : Text;
    S,S2    : String;
    DevTmp  : DevPtr;
    A,B     : CARDINAL;

FUNCTION FindVendor(Tag:String):BOOLEAN;

VAR Found : BOOLEAN;

BEGIN
 CurVend:=RVendor;
 Found:=FALSE;
 WHILE (CurVend<>NIL) AND NOT Found DO
 BEGIN
  IF CurVend^.VendorTag=Tag THEN
   Found:=TRUE
  ELSE
   Curvend:=CurVend^.NextVendor;
  END;
 FindVendor:=Found;
END;

FUNCTION FindDevice(Tag:String):BOOLEAN;

VAR Found : BOOLEAN;

BEGIN
 DevTmp:=CurVend^.DevTree;
 Found:=FALSE;
 WHILE (DevTmp<>NIL) AND NOT Found DO
  BEGIN
   IF DevTmp^.DeviceTag=Tag THEN
    Found:=TRUE
   ELSE
    DevTmp:=DevTmp^.NextDev;
  END;
 FindDevice:=Found;
END;

FUNCTION FindVendor(ID:CARDINAL):BOOLEAN;

VAR Found : BOOLEAN;

BEGIN
 CurVend:=RVendor;
 Found:=FALSE;
 WHILE (CurVend<>NIL) AND NOT Found DO
 BEGIN
  IF CurVend^.VendorID=ID THEN
   Found:=TRUE
  ELSE
   Curvend:=CurVend^.NextVendor;
  END;
 FindVendor:=Found;
END;

FUNCTION FindDevice(ID:CARDINAL):BOOLEAN;

VAR Found : BOOLEAN;

BEGIN
 DevTmp:=CurVend^.DevTree;
 Found:=FALSE;
 WHILE (DevTmp<>NIL) AND NOT Found DO
  BEGIN
   IF DevTmp^.DeviceID=ID THEN
    Found:=TRUE
   ELSE
    DevTmp:=DevTmp^.NextDev;
  END;
 FindDevice:=Found;
END;

CONST
  PCI_ADDR = $cf8;
  PCI_DATA = $cfc;
  BusCount = 8;

PROCEDURE PCIVendorNrs;

VAR
  PCIAddress : LongInt;
  PCIData    : LongInt;
  I          : LongInt;
  Found      : BOOLEAN;
BEGIN
  Writeln('Scanning for PCI devices'); Writeln;
  PCIAddress := $80000000;
  Found:=FALSE;
  FOR I := 0 TO (BusCount*32)-1 DO
  BEGIN
    IF NOT Found THEN
     BEGIN
       Found:=TRUE;
      Writeln('PCI-Addr Vendor                                  Model ' );
    END;

    OutportL(PCI_ADDR, PCIAddress);
    PCIData:=Inportl (PCI_DATA);
    IF PCIData <> $FFFFFFFF THEN
    BEGIN
      WrLngHex(PCIAddress); Write(' ');
      IF FindVendor(PCIData AND $FFFF) THEN
       WrStrAdj(CurVend^.VendorName,-40)
      ELSE
       BEGIN
        WrStrAdj('Unknown (',-35);
        WrHex(PCIData AND $FFFF); Write(')');
       END;
      IF FindDevice(PCIData SHR 16) THEN
       Write(DevTmp^.DeviceName)
      ELSE
       BEGIN
        Write('Unknown (');
        WrHex(PCIData SHR 16); Write(')');
       END;
      WriteLn;
    END;
    Inc( PCIAddress, $800 );
  END;
END;

CONST DefaultLoc='../devel/pcidata.txt';
      Defaultname='pcidata.txt';

BEGIN
 ClrScr;
 RVendor:=NIL;
 CurVend:=NIL;
 S:=DefaultName;
 IF NOT FileExists(S) THEN
  BEGIN
   S:=FSearch(Defaultname,GetEnv('PATH'));
   IF S='' then
    IF FileExists(DefaultLoc) THEN
      S:=DefaultLoc;
   IF S='' THEN
    BEGIN
     Writeln('PCI Data file not found');
     EXIT;
    END;
   END;
 Assign(F,S);
 Reset(F);
 REPEAT
  ReadLn(F,S);
  IF (S[1]<>'#') AND (Length(S)>0) THEN
   BEGIN
    ItemS(S2,S,' _(',0);
    B:=ORD(S2[1])+ (ORD(S[Length(S2)+1]) SHL 8);
    Delete(S,1,Length(S2)+1);
    CASE B OF
     $5F56 :  BEGIN  {VendorID}
               StripChar(S,' ');
               Item(S2,S,'=',0);
               IF RVendor=NIL THEN
                BEGIN
                 NEW(RVendor);
                 CurVend:=RVendor;
                END
               ELSE
                BEGIN
                 Curvend:=RVendor;
                 WHILE CurVend^.NextVendor<>NIL DO CurVend:=CurVend^.NextVendor;
                 NEW(CurVend^.NextVendor);
                 CurVend:=CurVend^.NextVendor;
                END;
               CurVend^.NextVendor:=NIL;
               CurVend^.DevTree:=NIL;
               CurVend^.VendorTag:=S2;
               Item(S2,S,'=',1);
               Delete(S2,1,1);
               UpperCase(S2);
               CurVend^.VendorID:=StrToHex(S2,4);
              END;
     $5F44 :  BEGIN  {DeviceID}
               IF CurVend^.DevTree=NIL THEN
                BEGIN
                 NEW(CurVend^.DevTree);
                 DevTmp:=CurVend^.DevTree;
                END
               ELSE
                BEGIN
                 DevTmp:=CurVend^.DevTree;
                 WHILE DevTmp^.NextDev<>NIL DO DevTmp:=DevTmp^.NextDev;
                 NEW(DevTmp^.NextDev);
                 DevTmp:=DevTmp^.NextDev;
                END;
               DevTmp^.NextDev:=NIL;
               StripChar(S,' ');
               Item(S2,S,'=',0);
               DevTmp^.DeviceTag:=S2;
               Item(S2,S,'=',1);
               Delete(S2,1,1);
               UpperCase(S2);
               DevTmp^.DeviceID:=StrToHex(S2,4);
              END;
     $2844,
     $2842 :  BEGIN  {Bridge + DeviceName}
               Item(S2,S,',',0);
               IF NOT FindVendor(S2) THEN
                BEGIN
                 Writeln(' Couldn'#39't find vendor,',S2,' error in the devicename part (2nd list)');
                 HALT;
                END;
               ItemS(S2,S,', ',1);
               IF NOT FindDevice(S2) THEN
                BEGIN
                 Writeln(' Couldn'#39't find device',S2,' error in the devicename part (2nd list)');
                 HALT;
                END;
               GetBetween(S,S2,'"','"');
               DevTmp^.DeviceName:=S2;
              END;
    $2063 :  BEGIN              {CASE ... determine full vendor name}
              Delete(S,1,7);            { Delete Vendor_}
              Item(S2,S,':',0);
              IF NOT FindVendor(S2) THEN
               BEGIN
                Writeln(' Couldn'#39't find vendor,',S2,' error in the vendornames part (3rd list)');
                HALT;
               END;
              GetBetween(S,S2,'"','"');
              CurVend^.VendorName:=S2;
             END;
      END;
   END;
 UNTIL EOF(F);
 Close(F);
 PCIVendorNrs;
END;

BEGIN
 GenSysNfo_CMOS;         {Show CMOS info}
 GetKey;
 GenSys2;               {Try to detect some stupid TSR's}
 GetKey;
 DoUarts;
 GetKey;
 DriveList;
 GetKey;
 ScanPCI;
END.
