PROCEDURE WindowToBuf(X1,Y1,X2,Y2 :AbsCoord;VAR Buf : BufPtr;Allocate : BOOLEAN);
{ Plop a window to the buffer, if Allocate is true, Buf is unallocated, else
  it is properly allocated. Also saves Attributes}

VAR XDiff,A : INTEGER;

BEGIN
 XDiff:=X2-X1+1;      { Width of Window }
 IF Allocate THEN
  GetMem(Buf, (XDiff)*(Y2-Y1+1)*2 +Spare); { Allocate space }
 FOR A:=Y1-1 TO Y2-1 DO
  dpmi_dosmemget($0B800,2*(Width*A+X1-1),Buf^[2*(A-(Y1-1))*XDiff],XDiff*2);
END; {WindowToBuf}

PROCEDURE BufToWindow(X1,Y1,X2,Y2:AbsCoord;VAR Buf : BufPtr);
{ Plop a buffer back to the Window, Caller has to make sure the buffer is
for the right window size}

VAR XDiff,A: INTEGER;

BEGIN
 XDiff:=X2-X1+1;      { Width of Window }
 FOR A:=Y1-1 TO Y2-1 DO
  dpmi_dosmemput($0B800,2*(Width*A+X1-1),Buf^[2*(A-(Y1-1))*XDiff],XDiff*2);
END; {WindowToBuf}


PROCEDURE SpoolType(W:WinType);

BEGIN
 WITH W^.Def DO
 Writeln(DumpTxt,'X1:',X1,' Y1:',Y1,' X2:',X2,' Y2:',Y2,' Fore:',ORD(ForeGround),' Back:',ORD(Background),' Frame:',ORD(FrameOn=TRUE));
 WITH W^ DO
  Writeln(DumpTxt,'X1:',X1,' Y1:',Y1,' X2:',X2,' Y2:',Y2,' Hidden:',ORD(Hidden=True));
END;

PROCEDURE ShowWinStack(A : WORD);

VAR Cur : WinType;

BEGIN
 WriteLn(DumpTxt,'ShowWinStack ',A);
 Cur:=WindowList;
 WHILE Cur<>NIL DO
  BEGIN
   WriteLn(DumpTxt,Cur^.X1,' ',Cur^.X2);
   Cur:=Cur^.Next;
  END;
 Writeln(Dumptxt,'End');
END;


  { Used to verify correct positions of frame.
   GotoXY(1,1);
  FOR A:=0 TO 7 DO Write('1234567890');
  GotoXY(1,25);
  FOR A:=0 TO 6 DO Write('1234567890'); Write ('123456789');
  FOR A:=2 TO 24 DO
   BEGIN
    GotoXY(1,A); Write(A);
    IF A>9 THEN
     GotoXY( 79,A)
    ELSE
     GotoXY( 80,A);
    Write (A)
    END; {FOR}      }


{PROCEDURE Frame(X1,Y1,X2,Y2 : AbsCoord;CONST Style:String;ColFore,ColBack:BYTE);
{Create a frame on AbsCoords X1,Y1,X2,Y2, use style "Style", in Colors ColFore and
        ColBack}

VAR Col,B : INTEGER;

BEGIN
 Col:=(ORD(ColFore)+ (ORD(ColBack) SHL 4)) SHL 8;
 B:=X2-X1;
 dosmemfillword(ScreenSeg,2*(Width*(Y1-1)+X1-1),1,ORD(Style[1])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y1-1)+X1),B-1,ORD(Style[5])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y1-1)+X2-1),1,ORD(Style[2])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y2-1)+X1-1),1,ORD(Style[3])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y2-1)+X1),B-1,ORD(Style[5])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y2-1)+X2-1),1,ORD(Style[4])+Col);

 FOR B:=Y1 TO Y2-2 DO
  BEGIN
   dosmemfillword(ScreenSeg,2*(Width*B+X1-1),1,ORD(Style[6])+Col);
   dosmemfillword(ScreenSeg,2*(Width*B+X2-1),1,ORD(Style[6])+Col);
  END;
END; {Frame}}

PROCEDURE InClear(X1,Y1,X2,Y2 : AbsCoord;ColFore,ColBack:BYTE);
{ Clear Window X1,Y1,X2,Y2 (Frame incl) with colors
   Meant as an internal, therefore the in before the name}

VAR Col,B : INTEGER;

BEGIN
 Write('Systeem');
 Col:=(ORD(ColFore)+ (ORD(ColBack) SHL 4)) SHL 8+32;
 FOR B:=Y1-1 TO Y2-1 DO
   dosmemfillword(ScreenSeg,2*(Width*B+X1-1),X2-X1+1,Col);
END; {InClear}

{PROCEDURE Frame(X1,Y1,X2,Y2 : AbsCoord;CONST Style:string;ColFore,ColBack:BYTE);
{Create a frame on AbsCoords X1,Y1,X2,Y2, use style "Style", in Colors ColFore and
            ColBack}

VAR Col,A,B : INTEGER;
    WMax,WMin : INTEGER;


BEGIN
 WMax:=WindMax; WMin:=WindMin;
 WINDOW(1,1,Width,Height);

 TextColor(ColFore); TextBackground(ColBack);
 B:=X2-X1;
 GotoXY(X1,Y1);
 Write(Style[1]); FOR A:= 0 TO B-2 DO Write (Style[5]); Write(Style[2]);
 GotoXY(X1,Y2);
 Write(Style[3]); FOR A:= 0 TO B-2 DO Write (Style[5]); Write(Style[4]);
 FOR B:=Y1+1 TO Y2-1 DO
  BEGIN
   GotoXY(X1,B); Write(Style[6]);    GotoXY(X2,B); Write(Style[6]);
  END;

 END;} {Frame}


PROCEDURE InClear(X1,Y1,X2,Y2 : AbsCoord;ColFore,ColBack:BYTE);
{ Clear Window X1,Y1,X2,Y2 (Frame incl) with colors
   Meant as an internal, therefore the 'in' before the name}


VAR Col,B     : INTEGER;
    WMax,WMin : INTEGER;

BEGIN
 WINDOW(1,1,80,25);
{ WindMax:=$184F; WindMin:=0;}

 TextColor(ColFore); TextBackground(ColBack);
 FOR B:=Y1 TO Y2 DO
  BEGIN
   GotoXY(X1,B); Write(' ':(X2-X1+1));
  END;
END; {InClear}



PROCEDURE OneLineToScreen(W:WinType;V1,V2,Y : LONGINT);

{Rewrites Subrange X:=V1..V2 on line Y, which is in the Window W which
is not hidden. Caller must assure that!

Doesn't exist in Dosversion. One memput takes care of that.}

VAR A,B,Tmp : LONGINT;
    L,L2    : BYTE;

BEGIN

  Tmp:=V2-V1+1;
  IF Tmp>0 THEN
   BEGIN
    Window(1,1,Width,Height);
    GotoXY(V1,Y);
    B:=2*((Y-W^.Def.Y1)*(W^.Def.X2-W^.Def.X1+1)+v1-W^.Def.X1);
    L:=0;
    FOR A:= 0 TO Tmp-1 DO
     BEGIN
      L2:=W^.Buffer^[B+A*2+1];
      IF L<>L2 THEN
       ttyColor(L2); { exported by modified Linux Crt, see helptext}
      L:=L2;
      Write(CHR(W^.Buffer^[B+A*2]));
     END;
    END;
   WITH W^ DO
  Window(Xi1,Yi1,Xi2,Yi2);
END;


PROCEDURE RedrawScreen(X1,X2,Y1,Y2 : LONGINT);
 { Advanced units only redraw needed parts of the screen.
    To speed up development, entire screen is redrawed.
    In future I hope to implement a (faster) routine which only updates
    the needed parts

    The coordinates aren't used. Slow but stable :-)  }


VAR Cur : WinType;
  I     : INTEGER;

BEGIN
 { Clear screen with standard attributes, for when FullScreen is hidden }
 {$IFNDEF Linux}
 dosmemfillword(ScreenSeg,0,4000 {2*Width*Height},32+7*256);
 {$ELSE}
  ClrScr; {Crt can probably do a faster clearscreen under Linux}
 {$ENDIF}
 I:=0;
   Cur:=WindowList;
   WHILE Cur<> NIL DO
   BEGIN
    IF NOT Cur^.Hidden THEN WinBufToWindow(Cur);
    Cur:=Cur^.Next;
  END;
END;
{PROCEDURE WinFrame(W:WinType);
{Create a frame from a WindowType}

VAR Col,B : INTEGER;

BEGIN
IF W^.Def.FrameOn THEN
 BEGIN
 Col:=(ORD(W^.Def.FrameFore)+ (ORD(W^.Def.FrameBack) SHL 4)) SHL 8;
 WITH W^.Def DO
  BEGIN
 B:=X2-X1;
 dosmemfillword(ScreenSeg,2*(Width*(Y1-1)+X1-1),1,ORD(W^.Def.FrameDef[1])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y1-1)+X1),B-1,ORD(W^.Def.FrameDef[5])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y1-1)+X2-1),1,ORD(W^.Def.FrameDef[2])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y2-1)+X1-1),1,ORD(W^.Def.FrameDef[3])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y2-1)+X1),B-1,ORD(W^.Def.FrameDef[5])+Col);
 dosmemfillword(ScreenSeg,2*(Width*(Y2-1)+X2-1),1,ORD(W^.Def.FrameDef[4])+Col);

 FOR B:=Y1 TO Y2-2 DO
  BEGIN
   dosmemfillword(ScreenSeg,2*(Width*B+X1-1),1,ORD(W^.Def.FrameDef[6])+Col);
   dosmemfillword(ScreenSeg,2*(Width*B+X2-1),1,ORD(W^.Def.FrameDef[6])+Col);
  END;
 END;
 END;
END;} {WinFrame}
{PROCEDURE WinFrame(W:WinType);
{Create a frame from a WindowType}

VAR Col,A,B : INTEGER;
    WMax,WMin : INTEGER;

BEGIN
 IF W^.Def.FrameOn THEN
 BEGIN
  WITH W^.Def DO
  BEGIN
   WMax:=WindMax; WMin:=WindMin;
   WindMax:=$184F; WindMin:=0;      { Use fullscreen}
   TextColor(frameFore); TextBackground(frameBack);
   B:=X2-X1;
   GotoXY(X1,Y1);
   Write(FrameDef[1]);
   FOR A:= 0 TO B-2 DO Write (frameDef[5]);
   Write(FrameDef[2]);
   GotoXY(X1,Y2);
   Write(FrameDef[3]);
   FOR A:= 0 TO B-2 DO Write (FrameDef[5]);
   Write(FrameDef[4]);
   FOR B:=Y1+1 TO Y2-1 DO
    BEGIN
     GotoXY(X1,B); Write(FrameDef[6]);
     GotoXY(X2,B); Write(FrameDef[6]);
    END;
  WindMax:=WMax; WindMin:=WMin;
  END;
 END;
END;} {WinFrame}

PROCEDURE WinBufToWindow(W:WinType);
  {Plop a buffer to the screen, Caller has to make sure the buffer is
  for the right window size.}

  VAR XDiff,A: INTEGER;

BEGIN
  WITH W^.Def DO
    BEGIN
     XDiff:=X2-X1+1;      { Width of Window }
     FOR A:=Y1-1 TO Y2-1 DO
      IF A<Height THEN  {Safety, don't write below last line}
      dosmemput(ScreenSeg,2*(Width*A+X1-1),W^.Buffer^[2*(A-(Y1-1))*XDiff],XDiff*2);
    END;
END;

PROCEDURE WinBufToWindow(W:WinType);
  {Plop a buffer to the screen, Caller has to make sure the buffer is
  for the right window size.}

  VAR XDiff,A2,A,B,ScreenData: INTEGER;
      L,L2 : BYTE;

  BEGIN
   WINDOW(1,1,Width,Height);
   WITH W^.Def DO
    BEGIN
     XDiff:=X2-X1+1;      { Width of Window }
     FOR A:=0 TO Y2-Y1 DO
      BEGIN
       IF (A+Y1)<height THEN
        BEGIN
         GotoXY(X1,A+Y1);
         A2:=A*XDiff;
         L:=0;
         FOR B:=0 TO X2-X1 DO
           BEGIN
           L2:=W^.Buffer^[2*(B+A2)+1];
           IF L<>L2 THEN
            ttyColor(L2); { exported by modified Linux Crt, see helptext}
           L:=L2;
           Write(CHR(W^.Buffer^[2*(B+A2)]));
          END;
        END;
      END;
    END;
 WITH W^ DO
  Window(Xi1,Yi1,Xi2,Yi2);
END;


----

{               {$IFDEF Linux}
                                      { Linux, buffer in variable buf first}

                BEGIN


                 Ind1:=2*((YIn-WinVar^.Def.Y1)*(Vx2-Vx1+1)+V1-Vx1);
                 Ind2:=(V1-XIn1)*2;
                 FOR A:=0 TO 2*(Tmp)-1 DO      { overlap range to buffer}
                   Buf[Ind2+A]:=WinVar^.Buffer^[Ind1+A]
                 END;
               {$ELSE}
                {FPC & BP}
                {Dos is fast enough, write directly to vidmem}

                 dosmemput(ScreenSeg,2*(Width*(YIn-1)+V1-1),Buffer^[((V1-vx1)+
                     (YIn-Def.Y1)*(vx2-vx1+1))*2],Tmp*2);
                {$ENDIF}
             END;}


   {
   Param1:=FExpand(Param1);
   FindFirst(Param1,AnyFile-VolumeId,D);
   IF (Doserror=0) AND ((D.attr and directory)>0) THEN
    BEGIN
     StrPCopy(P1,Param1); StrCopy(P2,'*.*');
     EDirTree.FileScan(P1,P2,@ShowRecord);
     INC(Files,EDirTree.FoundCount);
     INC(Bytes,EDirTree.TotalBytes);
     INC(Dirs, EDirTree.FoundDirs);
    END}