program FixMake;
Uses Dos,EFIO {$IFDEF Linux},Linux {$ENDIF};

CONST TabLength=8;
      Unix=TRUE;
      ToTab=TRUE;

VAR F1,F2 : Text;
    S,S1,S2,S3 : String;
    X     : LONGINT;
    C : CHAR;
    A,B : LONGINT;

BEGIN
 IF ParamCount<>1 THEN
  BEGIN
   writeln('Usage fixmakefile <file>');
   HALT;
  END;
 S:=ParamStr(1);
 FSplit(S,S1,S2,S3);
 S1:=S1+'tmp.tmp';
 Assign(F1,S);
 Reset(F1);
 Assign(F2,S1);
 Rewrite(F2);
 REPEAT
  X:=0;
  Read(F1,C);
  IF NOT EOF(F1) THEN
   BEGIN
    IF C=#10 THEN
     Read(F1,C);
    IF (C=' ') OR (C=#9) THEN
     BEGIN
      WHILE ((C=' ') OR (C=#9)) AND NOT EOF(F1) DO
       BEGIN
        IF C=' ' THEN
         INC(X)
        ELSE
         X:=((X DIV TabLength)+1)*TabLength;
       Read(F1,C);
     END;
    IF (X<>0) THEN
     BEGIN
      IF ToTab THEN
       BEGIN
        A:=X DIV TabLength;
        B:=X MOD TabLength;
     IF A>0 THEN
      FOR X:=1 TO A DO
      Write(F2,#9);
     IF B>0 THEN
      Write(F2,' ':B);
    END
   ELSE
    Write(F2,' ':X);
  END;
 END;
 IF C<>#13 THEN
  Write(F2,C);
 Read(F1,C);
 WHILE ((C<>#13) AND (C<>#10)) AND NOT EOF(F1)  DO
  BEGIN
   Write(F2,C);
   Read(F1,C);
  END;
 IF NOT EOF(F1) THEN
  IF Unix THEN
   Write(F2,#10)
  ELSE
   Writeln(F2);
  END;
 UNTIL EOF(F1);
 Close(F1); Close(F2);
 S2:=S;
 ChangeExtension(S2,'bak');
 
 
 Writeln('Fixed :',S);
 IF FileExists(S2) THEN
  BEGIN
   Assign(F1,S2);
   Erase(F1);
  END;
 Assign(F1,S);
 Rename(F1,S2);
 Assign(F2,S1);
 Rename(F2,S);
END.


