PROGRAM INPUTTEST;

Uses Crt,EPasStr,ELib;
{$I keys.inc}

VAR FieldSpace : BYTE;

FUNCTION  InputStr(VAR S:String;X,Y,Len:CARDINAL;TextIn:BOOLEAN;CharAllow:CHARSET):BOOLEAN;

{ Since I'm in a hurry, I'll only translate the procedure heading:

  Input a string from keyboard, in a nice way,
   allowed characters are in CHARSET CharAllow, but several editting
   keys are always allowed, see CASE loop.

Theoretical limit of 80 characters, but this isn't tested, so you could reach
132 characters if you wish, but you'll have to make "UitG" bigger.

Parameters:

   X,Y       Coordinates field
   Len       Lengte field
   TextIn    S already filled?}

VAR
    InGev                     : CARDINAL; { No. of chars inputted }
    Posi                      : CARDINAL; { Cursorposition}
    Ins                       : BOOLEAN;  { Insert yes/no }
    Key                       : CARDINAL; { Last key as ELib.GetKey
                                            code <255 if normal key,
                                            >256 if special/function
                                            key. See keys.inc}
    Uitg                      : String;    {The inputted string}
    Full                      : BOOLEAN;   { Is the string full? }
    EndVal                    : WORD;

PROCEDURE ReWr; { Rewrite the field, using Uitg}

VAR    I                         : LONGINT;  { Temporary variabele }

BEGIN
 IF Length(Uitg)>Len THEN
  Uitg[0]:=CHR(Len);
 IF Length(Uitg)>0 THEN
  FOR I:= 1 TO Length(Uitg) DO
   BEGIN
    GotoXY(X+I,Y);
    IF Uitg[I]=CHR(32) THEN
     Write(CHR(FieldSpace))
    ELSE
     Write(Uitg[I]);
   END;
 IF Len<>Length(Uitg) THEN
  BEGIN
   GotoXY(X+Length(Uitg)+1,Y);
   FOR I:= Length(Uitg) TO Len-1 DO
    Write(CHR(FieldSpace));
  END;
{ GotoXY(5,5);
 Writeln(Len,Length(Uitg)); }

 
END;

PROCEDURE DoCursor; { Put Cursor in/out insert-mode }

BEGIN
 {$IFNDEF Linux}
 IF Ins THEN
  SetCursorSize($11E)
 ELSE
  SetCursorSize($71E);
 {$ENDIF}
END;

BEGIN
    { Init }

  InGev :=0;              { 0 chars untill now }
  Posi  :=1;               { Cursorposition 0 }
  Ins   :=TRUE;            { Insert according to parameters }
  DoCursor;        { Set cursor accordingly }
  Key   :=0;

       { put  padded field on screen }

  StrStr(Uitg,CHR(FieldSpace),Len);
  ReWr;
  GotoXY(X,Y);

  StrStr(Uitg,CHR(0),80);                  { Empty Uitg entirely }

  IF TextIn THEN
   BEGIN
    Uitg:=S;
    Posi:=Length(Uitg)+1;                        { Put a predefined }
    ReWr;                                   {  String on screen if specified }
   END;

  EndVal:=0;
  WHILE EndVal=0 DO
   BEGIN
    Full:=FALSE;
    IF ((Posi)>=Len) THEN
     BEGIN
      Full:=TRUE;
      Posi:=Len;
     END;
    GotoXY(X+Posi,Y);
    CursorOn;
    DoCursor;
    Key:=GetKey();
    CursorOff;
    CASE Key OF
          CR              : BEGIN
                             EndVal:=1;
                             S:=UitG;
                            END;
          ESC             : EndVal:=2;
          BS              : IF Posi>1 THEN       { BackSpace }
                              BEGIN
                               DEC(Posi);
                               Delete(Uitg,Posi,1);
                               DEC(InGev);
                               ReWr;
                              END;
          KDelete          : BEGIN
                              Delete(Uitg,Posi,1);
                              DEC(InGev);
                              ReWr;
                             END;
          ArrR            : IF (NOT Full) AND ((Posi-1)<InGev) THEN
                              BEGIN
                               INC (Posi);
                               GotoXY(X+Posi-1,Y);
                               END;
          KInsert          : BEGIN
                               Ins:= NOT Ins;
                               DoCursor;
                              END;
          ArrL            : IF (NOT (Posi=0)) THEN
                              BEGIN
                               DEC (Posi);
                               GotoXY(X+Posi-1,Y);
                              END;
          Home            : Posi:=1;
          KEnd            : Posi:=InGev-1;
          CtrlY           : BEGIN
                             Delete(Uitg,Posi,Length(Uitg)-Posi);
                             ReWr;
                            END;
          CtrlT           : BEGIN
                             Uitg[0]:=#0; Posi:=1; ReWr;
                            END;
    END; {Case}
   IF EndVal=0 THEN
    BEGIN
     IF (CHR(Key) IN CharAllow) THEN
      BEGIN
       IF Posi>Len THEN
        Posi:=Len;
       IF (Ins=FALSE) OR Full THEN
        BEGIN
         IF (ORD(Uitg[0])<Posi) THEN
           Uitg[0]:=CHR(Posi);
         Uitg[Posi]:=CHR(Key);
        END
       ELSE
        BEGIN
          InsertC(Uitg,CHR(Key),Posi);
        END;
       ReWr;
       INC(Posi);
      END;
     END;
    GotoXY(5,6);
    Write(Posi,' ',Len,' ',Length(Uitg),' ',ORD(Key));
    IF Full Then
     Write('Full')
    ELSE
     Write('       ');
    GotoXY(5,7);
    write('                               ');
    GotoXY(5,7);
    Write(Uitg);
    InGev:=Length(Uitg);
   END;
  InputStr:=Endval=1;
END;

CONST AlfaBeta : CHARSET= [' '..'z'];

VAR S :String;

    Fl : BOOLEAN;


BEGIN
 ClrScr;
 FieldSpace:=177;
 S:='12345';
 Fl:=InputStr(S,10,10,5,TRUE,Alfabeta);
 GotoXY(1,20);
 Writeln(S);
END.
