Program MyOpt;
{ I like GetOpts, but it's a pity that the unit can't emulate certain
   commandline styles of certain utilities. I had a simple procedure which
   did such a thing, and updated it a bit so you can use quotes.

  I'll try to get the interface similar to GetOpts, so it can be used in a
  similar way.

  This is just a thought experiment, using old M2 code. I plan to use GetOpts
  in the future

  }


Uses EPasStr,Dos,ELib;

FUNCTION GetSwitch(VAR S,S2:String;Ch:CHAR):BOOLEAN;

CONST Sep : CHARSET=['/','-',' '];

VAR  Len,A,B,C: LONGINT;
     InSep  : CHARSET;

BEGIN
 Len:=Length(S);        {String is not 0 terminated, have to check for length
                         (Zero terminated strings have #0 in InSep}
 A:=Pos(Ch,S);
 IF A=0 THEN            {Separator in String?}
  BEGIN
   GetSwitch:=FALSE;
   EXIT;
  END;
 InSep:=Sep;            { Default separators?}
 B:=1;
 C:=A;
 WHILE NOT (S[C+B] IN InSep) AND ((C+B)<=Len) DO
  BEGIN
   IF (S[C+B]='"') OR (S[A+B]=CHR(39)) THEN  {Delimiters?}
    BEGIN
     Insep:=[S[C+b]];     {Delimiter detected, end-conditions change}
     INC(C);
    END
   ELSE
    BEGIN
     S2[B]:=S[C+B];
     INC (B)
    END;
  END;
 IF NOT ('/' IN InSep) THEN
  INC(B,2);                     {Also delete delimiters}
 S2[0]:=CHR(B-1);
 Delete(S,A,B);
 GetSwitch:=TRUE;
END;

VAR InParam,ThisSwitch : String;
    A                  : WORD;
    Fl : BOOLEAN;

BEGIN
 InParam:=GetEnv('CMDLINE');
 Writeln(InParam);
 Fl:=TRUE;
 WHILE GetSwitch(InParam,ThisSwitch,'-')  AND Fl DO
  BEGIN
   Writeln(ThisSwitch);
   Writeln(InParam);
   A:=GetKey();
   IF A=13 THEN
    Fl:=FALSE;
   END;
  Fl:=TRUE;
 WHILE GetSwitch(InParam,ThisSwitch,'/') AND Fl DO
   BEGIN
    Writeln(ThisSwitch);
    Writeln(InParam);
    A:=GetKey();
    IF A=13 THEN
     Fl:=FALSE;
   END;
 A:=1;          { Omit first name}
 REPEAT
  Item (ThisSwitch,InParam,' ',A);
  Writeln(A,ThisSwitch);
  INC(A);
 UNTIL ThisSwitch[0]=CHR(0);
END.
