PROGRAM UnixTest;

{Tests Unix-date procedures

Takes REALLY long. I terminated it after 10 minutes. (Cyrix P166+)

What does it do?

First it loops through every day between 1-1-1970 and 31-12-2099 and checks
if the diffence between midnight of both days is 60*60*24 seconds.
This works except for the first day ( first midnight=0, variable is initialised
zero and zero-zero=zero, not 60*60*24), which is normal.
   ( 1-1-1970=Unix day-zero, expiration date of these routines is 3-1-2100))

The second loop, which is the very slow, runs thru every second in above
interval, and checks if the ToUnix date (HHMMSS-DDMMYY to Unix) and FromUnix
(the other way around) match.

If you don't have that much patience, delete the inner (HHMMSS) loops.
}

Uses EDate;

TYPE
   Array12Type = ARRAY [1..12] OF WORD;

CONST
   MonthDays : Array12Type=(31,28,31,30,31,30,31,31,30,31,30,31);

VAR Y,M,D,H,Min,S       : LONGINT;
    Y2,M2,D2,H2,Min2,S2 : LONGINT;
    FebCor              : LONGINT;
    I,J                 : CARDINAL;
    Wrong               : BOOLEAN;

BEGIN
 Writeln('This program calculates the unixdate for each second between 1970 and 2100, and then back to DDMMYY');
 Writeln('It also calculates the difference (in seconds) between two sequential days, and compares that with 60*60*24');
 Writeln('You should only see one days dont match error below (the first day)');

 H:=0; Min:=0; S:=0;
 FOR Y:=1970 TO 2099 DO   {Test Unix dates, years loop}
  FOR M:=1 TO 12 DO        {Months loop}
   BEGIN
    FebCor:=MonthDays[M];       {Days for a given month}
    IF LeapYr(Y) AND (M=2) THEN {LeapYear correction}
     INC(FebCor);
    FOR D:=1 TO FebCor DO       {Days loop}
     BEGIN
      I:=J;
      J:=ToUnix(Y,M,D,H,Min,S);
      IF (J-I)<>86400 THEN        { If difference between two days is not
                                    24*60*60, then somethings wrong}
      Writeln('Days dont match');
     END;
    END;
 FOR Y:=1970 TO 2099 DO   {Test Unix dates}
  BEGIN
   Write(Y,' ');
  FOR M:=1 TO 12 DO     {Test Months}
   BEGIN
    Write(M:3,' ');
    FebCor:=MonthDays[M];
    IF LeapYr(Y) AND (M=2) THEN
     INC(FebCor);
    FOR D:=1 TO FebCor DO
     FOR H:=0 TO 23 DO
      FOR Min:=0 TO 59 DO
       FOR S:=0 TO 59 DO
        BEGIN
         Wrong:=FALSE;
         I:=J;
         J:=ToUnix(Y,M,D,H,Min,S);
         FromUnix(J,Y2,M2,D2,H2,Min2,S2);
         IF (Y2<>Y) OR (M2<>M) THEN
          Wrong:=TRUE;
         IF (D2<>D) OR (H<>H2) THEN
          Wrong:=TRUE;
         IF (S2<>S) OR (Min2<>Min) THEN
          Wrong:=TRUE;
         IF Wrong THEN
          Writeln(Y,' ',M,' ',' ',D,' ',Y2,' ',M2,' ',D2);
         END;
      END;
       Writeln;
   END;
END.

